﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data;

namespace basekibali
{
    public partial class AgriCapture : System.Web.UI.Page
    {
        protected void Page_Init(object sender, EventArgs e)
        {
            if (User.Identity.IsAuthenticated) { }
            else
                Response.Redirect("~/Default.aspx");

            SetDropDown(DropDownInterviewer, GetInterviewerForDropDown());
            SetDropDown(DropDownVillage, GetVillagesForDropDown());
            TblHouseHold.Focus();
        }
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!Page.IsPostBack)
            {
                TreeFirstGridViewRow();
                FieldFirstGridViewRow();
                CropFirstGridViewRow();
            }
        }
        private void SetDropDown(DropDownList ddl,IQueryable source)
        {
            ddl.AppendDataBoundItems = true;
            ddl.DataSource = source;
            ddl.DataTextField = "Text";
            ddl.DataValueField = "Value";
            ddl.DataBind();
        }
        /*Get projects for drop down menu*/
        private IQueryable GetProjectsForDropDown()
        {
            DataKibaliDataContext db = new DataKibaliDataContext();
            var items = from p in db.PROJECTs
                        select new
                        {
                            Text = p.Name,
                            Value = p.Name
                        };
            return items.OrderBy(x => x.Text);
        }

        #region Village and Interview ddl

        /*Get interviewer for drop down menu*/
        private IQueryable GetInterviewerForDropDown()
        {
            DataKibaliDataContext db = new DataKibaliDataContext();
            var items = from i in db.INTERVIEWERs
                        select new
                        {
                            Text = i.Name,
                            Value = i.Name
                        };
            return items.OrderBy(x => x.Text);
        }
        private IQueryable GetVillagesForDropDown()
        {
            DataKibaliDataContext db = new DataKibaliDataContext();
            var items = from v in db.VILLAGEs
                        select new
                        {
                            Text = v.Name,
                            Value = v.Name
                        };
            return items.OrderBy(x => x.Text);
        }
        #endregion

        #region Trees GridView

        /*Get ownerships for drop down menu*/
        private IQueryable GetTreesForDropDown()
        {
            DataKibaliDataContext db = new DataKibaliDataContext();
            var items = from t in db.TREEs
                        select new
                        {
                            Text = t.Name,
                            Value = t.Name
                        };
            return items.OrderBy(x => x.Text);
        }

        public void TreeFirstGridViewRow()
        {
            DataTable dt = new DataTable();
            DataRow dr = null;
            dt.Columns.Add(new DataColumn("Row_Number", typeof(string)));
            dt.Columns.Add(new DataColumn("DropDownTree", typeof(string)));
            dt.Columns.Add(new DataColumn("txtProductive", typeof(string)));
            dt.Columns.Add(new DataColumn("txtGpsNorth", typeof(string)));
            dt.Columns.Add(new DataColumn("txtGpsEast", typeof(string)));
            dt.Columns.Add(new DataColumn("DropProjectTree", typeof(string)));
            dr = dt.NewRow();
            dr["Row_Number"] = 1;
            dr["DropDownTree"] = string.Empty;
            dr["txtProductive"] = string.Empty;
            dr["txtGpsNorth"] = string.Empty;
            dr["txtGpsEast"] = string.Empty;
            dr["DropProjectTree"] = string.Empty;
            dt.Rows.Add(dr);

            ViewState["TreeTable"] = dt;


            TreeDetails.DataSource = dt;
            TreeDetails.DataBind();

            SetPreviousTreeData();

            Button btnTreeAdd = (Button)TreeDetails.FooterRow.Cells[6].FindControl("ButtonAdd");
            Page.Form.DefaultFocus = btnTreeAdd.ClientID;
        }
        private void AddNewTreeRow()
        {
            int rowIndex = 0;

            if (ViewState["TreeTable"] != null)
            {
                DataTable dtTreeTable = (DataTable)ViewState["TreeTable"];
                DataRow drCurrentRow = null;
                if (dtTreeTable.Rows.Count > 0)
                {
                    for (int i = 1; i <= dtTreeTable.Rows.Count; i++)
                    {
                        DropDownList DrpTree = (DropDownList)TreeDetails.Rows[rowIndex].Cells[1].FindControl("DropDownTree");
                        TextBox TextBoxtxtProductive = (TextBox)TreeDetails.Rows[rowIndex].Cells[2].FindControl("txtProductive");
                        TextBox txtGpsNorth = (TextBox)TreeDetails.Rows[rowIndex].Cells[3].FindControl("txtGpsNorth");
                        TextBox txtGpsEast = (TextBox)TreeDetails.Rows[rowIndex].Cells[4].FindControl("txtGpsEast");
                        DropDownList DrpProject = (DropDownList)TreeDetails.Rows[rowIndex].Cells[5].FindControl("DropProjectTree");
                        

                        SetDropDown(DrpTree, GetTreesForDropDown());
                        SetDropDown(DrpProject, GetProjectsForDropDown());

                        drCurrentRow = dtTreeTable.NewRow();
                        drCurrentRow["Row_Number"] = i + 1;

                        dtTreeTable.Rows[i - 1]["DropDownTree"] = DrpTree.SelectedValue;
                        dtTreeTable.Rows[i - 1]["txtProductive"] = TextBoxtxtProductive.Text;
                        dtTreeTable.Rows[i - 1]["txtGpsNorth"] = txtGpsNorth.Text;
                        dtTreeTable.Rows[i - 1]["txtGpsEast"] = txtGpsEast.Text;
                        dtTreeTable.Rows[i - 1]["DropProjectTree"] = DrpProject.SelectedValue;

                        rowIndex++;
                    }
                    dtTreeTable.Rows.Add(drCurrentRow);
                    ViewState["TreeTable"] = dtTreeTable;

                    TreeDetails.DataSource = dtTreeTable;
                    TreeDetails.DataBind();
                }
            }
            else
            {
                Response.Write("ViewState is null");
            }
            SetPreviousTreeData();
        }
        private void SetPreviousTreeData()
        {
            int rowIndex = 0;
            if (ViewState["TreeTable"] != null)
            {
                DataTable dt = (DataTable)ViewState["TreeTable"];
                if (dt.Rows.Count > 0)
                {
                    for (int i = 0; i < dt.Rows.Count; i++)
                    {

                        DropDownList DrpTree = (DropDownList)TreeDetails.Rows[rowIndex].Cells[1].FindControl("DropDownTree");
                        TextBox TextBoxtxtProductive = (TextBox)TreeDetails.Rows[rowIndex].Cells[2].FindControl("txtProductive");
                        TextBox txtGpsNorth = (TextBox)TreeDetails.Rows[rowIndex].Cells[3].FindControl("txtGpsNorth");
                        TextBox txtGpsEast = (TextBox)TreeDetails.Rows[rowIndex].Cells[4].FindControl("txtGpsEast");
                        DropDownList DrpProject = (DropDownList)TreeDetails.Rows[rowIndex].Cells[5].FindControl("DropProjectTree");
                        // drCurrentRow["Row_Number"] = i + 1;

                        SetDropDown(DrpTree, GetTreesForDropDown());
                        SetDropDown(DrpProject, GetProjectsForDropDown());

                        TreeDetails.Rows[i].Cells[0].Text = Convert.ToString(i + 1);
                        DrpTree.SelectedValue = dt.Rows[i]["DropDownTree"].ToString();
                        TextBoxtxtProductive.Text = dt.Rows[i]["txtProductive"].ToString();
                        txtGpsNorth.Text = dt.Rows[i]["txtGpsNorth"].ToString();
                        txtGpsEast.Text = dt.Rows[i]["txtGpsEast"].ToString();
                        DrpProject.SelectedValue = dt.Rows[i]["DropProjectTree"].ToString();
                        rowIndex++;
                    }
                }
            }

        }
        protected void ButtonAdd_Click(object sender, EventArgs e)
        {
            AddNewTreeRow();
        }
        protected void TreeDetails_RowDeleting(object sender, GridViewDeleteEventArgs e)
        {
            SetTreeRowData();
            if (ViewState["TreeTable"] != null)
            {
                DataTable dt = (DataTable)ViewState["TreeTable"];
                DataRow drCurrentRow = null;
                int rowIndex = Convert.ToInt32(e.RowIndex);
                if (dt.Rows.Count > 1)
                {
                    dt.Rows.Remove(dt.Rows[rowIndex]);
                    drCurrentRow = dt.NewRow();
                    ViewState["TreeTable"] = dt;
                    TreeDetails.DataSource = dt;
                    TreeDetails.DataBind();

                    for (int i = 0; i < TreeDetails.Rows.Count - 1; i++)
                    {
                        TreeDetails.Rows[i].Cells[0].Text = Convert.ToString(i + 1);
                    }
                    SetPreviousTreeData();
                }
            }
        }
        private void SetTreeRowData()
        {
            int rowIndex = 0;

            if (ViewState["TreeTable"] != null)
            {
                DataTable dtTreeTable = (DataTable)ViewState["TreeTable"];
                DataRow drCurrentRow = null;
                if (dtTreeTable.Rows.Count > 0)
                {
                    for (int i = 1; i <= dtTreeTable.Rows.Count; i++)
                    {
                        DropDownList DrpTree = (DropDownList)TreeDetails.Rows[rowIndex].Cells[1].FindControl("DropDownTree");
                        TextBox TextBoxtxtProductive = (TextBox)TreeDetails.Rows[rowIndex].Cells[2].FindControl("txtProductive");
                        TextBox txtGpsNorth = (TextBox)TreeDetails.Rows[rowIndex].Cells[3].FindControl("txtGpsNorth");
                        TextBox txtGpsEast = (TextBox)TreeDetails.Rows[rowIndex].Cells[4].FindControl("txtGpsEast");
                        DropDownList DrpProject = (DropDownList)TreeDetails.Rows[rowIndex].Cells[5].FindControl("DropProjectTree");

                        SetDropDown(DrpTree, GetTreesForDropDown());
                        SetDropDown(DrpProject, GetProjectsForDropDown());

                        drCurrentRow = dtTreeTable.NewRow();
                        drCurrentRow["Row_Number"] = i + 1;
                        dtTreeTable.Rows[i - 1]["DropDownTree"] = DrpTree.SelectedValue;
                        dtTreeTable.Rows[i - 1]["txtProductive"] = TextBoxtxtProductive.Text;
                        dtTreeTable.Rows[i - 1]["txtGpsNorth"] = txtGpsNorth.Text;
                        dtTreeTable.Rows[i - 1]["txtGpsEast"] = txtGpsEast.Text;
                        dtTreeTable.Rows[i - 1]["DropProjectTree"] = DrpProject.SelectedValue;

                        rowIndex++;
                    }

                    ViewState["TreeTable"] = dtTreeTable;
                    //TreeDetails.DataSource = dtTreeTable;
                    //TreeDetails.DataBind();
                }
            }
            else
            {
                Response.Write("ViewState is null");
            }
        }
        protected void TreeDetails_PreRender(object sender, EventArgs e)
        {
            ClientScriptManager cs = Page.ClientScript;
            foreach (GridViewRow grdrow in TreeDetails.Rows)
            {
                DropDownList drpgrdDropDownTree = (DropDownList)grdrow.FindControl("DropDownTree");
                TextBox txtgrdProductive = (TextBox)grdrow.FindControl("txtProductive");
                TextBox txtgrdGpsNorth = (TextBox)grdrow.FindControl("txtGpsNorth");
                TextBox txtgrdGpsEast = (TextBox)grdrow.FindControl("txtGpsEast");
                DropDownList drpgrdDropProjectTree = (DropDownList)grdrow.FindControl("DropProjectTree");
                cs.RegisterArrayDeclaration("grdDropDownTree_Drp", String.Concat("'", drpgrdDropDownTree.ClientID, "'"));
                cs.RegisterArrayDeclaration("grdProductive_Txt", String.Concat("'", txtgrdProductive.ClientID, "'"));
                cs.RegisterArrayDeclaration("grdTGpsNorth_Txt", String.Concat("'", txtgrdGpsNorth.ClientID, "'"));
                cs.RegisterArrayDeclaration("grdTGpsEast_Txt", String.Concat("'", txtgrdGpsEast.ClientID, "'"));
                cs.RegisterArrayDeclaration("grdDropProjectTree_Drp", String.Concat("'", drpgrdDropProjectTree.ClientID, "'"));
            }
        }
        #endregion

        #region Fields GridView

        /*Get ownerships for drop down menu*/
        private IQueryable GetOwnershipsForDropDown()
        {
            DataKibaliDataContext db = new DataKibaliDataContext();
            var items = from o in db.FIELDSOWNERSHIPs
                        select new
                        {
                            Text = o.Title,
                            Value = o.Title
                        };
            return items.OrderBy(x => x.Text);
        }

        public void FieldFirstGridViewRow()
        {
            DataTable dt = new DataTable();
            DataRow dr = null;
            dt.Columns.Add(new DataColumn("RowNumber", typeof(string)));
            dt.Columns.Add(new DataColumn("DropOwnership", typeof(string)));
            dt.Columns.Add(new DataColumn("txtDimension", typeof(string)));
            dt.Columns.Add(new DataColumn("CheckLast12", typeof(string)));
            dt.Columns.Add(new DataColumn("txtFGpsN", typeof(string)));
            dt.Columns.Add(new DataColumn("txtFGpsE", typeof(string)));
            dt.Columns.Add(new DataColumn("DropProject", typeof(string)));
            dr = dt.NewRow();
            dr["RowNumber"] = 1;
            dr["DropOwnership"] = string.Empty;
            dr["txtDimension"] = string.Empty;
            dr["CheckLast12"] = string.Empty;
            dr["txtFGpsN"] = string.Empty;
            dr["txtFGpsE"] = string.Empty;
            dr["DropProject"] = string.Empty;
            dt.Rows.Add(dr);

            ViewState["FieldTable"] = dt;


            FieldDetails.DataSource = dt;
            FieldDetails.DataBind();

            SetPreviousFieldData();

            Button btnFieldAdd = (Button)FieldDetails.FooterRow.Cells[7].FindControl("ButtonFieldAdd");
            Page.Form.DefaultFocus = btnFieldAdd.ClientID;
        }
        private void AddNewFieldRow()
        {
            int rowIndex = 0;

            if (ViewState["FieldTable"] != null)
            {
                DataTable dtFieldTable = (DataTable)ViewState["FieldTable"];
                DataRow drCurrentRow = null;
                if (dtFieldTable.Rows.Count > 0)
                {
                    for (int i = 1; i <= dtFieldTable.Rows.Count; i++)
                    {
                        DropDownList DrpOwnership = (DropDownList)FieldDetails.Rows[rowIndex].Cells[1].FindControl("DropOwnership");
                        TextBox TextBoxDimension = (TextBox)FieldDetails.Rows[rowIndex].Cells[2].FindControl("txtDimension");
                        CheckBoxList CheckLast12 = (CheckBoxList)FieldDetails.Rows[rowIndex].Cells[3].FindControl("CheckLast12");
                        TextBox txtFGpsN = (TextBox)FieldDetails.Rows[rowIndex].Cells[4].FindControl("txtFGpsN");
                        TextBox txtFGpsE = (TextBox)FieldDetails.Rows[rowIndex].Cells[5].FindControl("txtFGpsE");
                        DropDownList DrpProject = (DropDownList)FieldDetails.Rows[rowIndex].Cells[6].FindControl("DropProject");

                        SetDropDown(DrpOwnership, GetOwnershipsForDropDown());
                        SetDropDown(DrpProject, GetProjectsForDropDown());

                        drCurrentRow = dtFieldTable.NewRow();
                        drCurrentRow["RowNumber"] = i + 1;

                        dtFieldTable.Rows[i - 1]["DropOwnership"] = DrpOwnership.SelectedValue;
                        dtFieldTable.Rows[i - 1]["txtDimension"] = TextBoxDimension.Text;
                        dtFieldTable.Rows[i - 1]["CheckLast12"] = CheckLast12.SelectedValue;
                        dtFieldTable.Rows[i - 1]["txtFGpsN"] = txtFGpsN.Text;
                        dtFieldTable.Rows[i - 1]["txtFGpsE"] = txtFGpsE.Text;
                        dtFieldTable.Rows[i - 1]["DropProject"] = DrpProject.SelectedValue;

                        rowIndex++;
                    }
                    dtFieldTable.Rows.Add(drCurrentRow);
                    ViewState["FieldTable"] = dtFieldTable;

                    FieldDetails.DataSource = dtFieldTable;
                    FieldDetails.DataBind();
                }
            }
            else
            {
                Response.Write("ViewState is null");
            }
            SetPreviousFieldData();
        }
        private void SetPreviousFieldData()
        {
            int rowIndex = 0;
            if (ViewState["FieldTable"] != null)
            {
                DataTable dt = (DataTable)ViewState["FieldTable"];
                if (dt.Rows.Count > 0)
                {
                    for (int i = 0; i < dt.Rows.Count; i++)
                    {

                        DropDownList DrpOwnership = (DropDownList)FieldDetails.Rows[rowIndex].Cells[1].FindControl("DropOwnership");
                        TextBox TextBoxDimension = (TextBox)FieldDetails.Rows[rowIndex].Cells[2].FindControl("txtDimension");
                        CheckBoxList CheckLast12 = (CheckBoxList)FieldDetails.Rows[rowIndex].Cells[3].FindControl("CheckLast12");
                        TextBox txtFGpsN = (TextBox)FieldDetails.Rows[rowIndex].Cells[4].FindControl("txtFGpsN");
                        TextBox txtFGpsE = (TextBox)FieldDetails.Rows[rowIndex].Cells[5].FindControl("txtFGpsE");
                        DropDownList DrpProject = (DropDownList)FieldDetails.Rows[rowIndex].Cells[6].FindControl("DropProject");
                        // drCurrentRow["RowNumber"] = i + 1;

                        SetDropDown(DrpOwnership, GetOwnershipsForDropDown());
                        SetDropDown(DrpProject, GetProjectsForDropDown());

                        FieldDetails.Rows[i].Cells[0].Text = Convert.ToString(i + 1);
                        DrpOwnership.SelectedValue = dt.Rows[i]["DropOwnership"].ToString();
                        TextBoxDimension.Text = dt.Rows[i]["txtDimension"].ToString();
                        CheckLast12.SelectedValue = dt.Rows[i]["CheckLast12"].ToString();
                        txtFGpsN.Text = dt.Rows[i]["txtFGpsN"].ToString();
                        txtFGpsE.Text = dt.Rows[i]["txtFGpsE"].ToString();
                        DrpProject.SelectedValue = dt.Rows[i]["DropProject"].ToString();
                        rowIndex++;
                    }
                }
            }

        }
        protected void ButtonFieldAdd_Click(object sender, EventArgs e)
        {
            AddNewFieldRow();
        }
        protected void FieldDetails_RowDeleting(object sender, GridViewDeleteEventArgs e)
        {
            SetFieldRowData();
            if (ViewState["FieldTable"] != null)
            {
                DataTable dt = (DataTable)ViewState["FieldTable"];
                DataRow drCurrentRow = null;
                int rowIndex = Convert.ToInt32(e.RowIndex);
                if (dt.Rows.Count > 1)
                {
                    dt.Rows.Remove(dt.Rows[rowIndex]);
                    drCurrentRow = dt.NewRow();
                    ViewState["FieldTable"] = dt;
                    FieldDetails.DataSource = dt;
                    FieldDetails.DataBind();

                    for (int i = 0; i < FieldDetails.Rows.Count - 1; i++)
                    {
                        FieldDetails.Rows[i].Cells[0].Text = Convert.ToString(i + 1);
                    }
                    SetPreviousFieldData();
                }
            }
        }
        private void SetFieldRowData()
        {
            int rowIndex = 0;

            if (ViewState["FieldTable"] != null)
            {
                DataTable dtFieldTable = (DataTable)ViewState["FieldTable"];
                DataRow drCurrentRow = null;
                if (dtFieldTable.Rows.Count > 0)
                {
                    for (int i = 1; i <= dtFieldTable.Rows.Count; i++)
                    {
                        DropDownList DrpOwnership = (DropDownList)FieldDetails.Rows[rowIndex].Cells[1].FindControl("DropOwnership");
                        TextBox TextBoxDimension = (TextBox)FieldDetails.Rows[rowIndex].Cells[2].FindControl("txtDimension");
                        CheckBoxList CheckLast12 = (CheckBoxList)FieldDetails.Rows[rowIndex].Cells[3].FindControl("CheckLast12");
                        TextBox txtFGpsN = (TextBox)FieldDetails.Rows[rowIndex].Cells[4].FindControl("txtFGpsN");
                        TextBox txtFGpsE = (TextBox)FieldDetails.Rows[rowIndex].Cells[5].FindControl("txtFGpsE");
                        DropDownList DrpProject = (DropDownList)FieldDetails.Rows[rowIndex].Cells[6].FindControl("DropProject");

                        SetDropDown(DrpOwnership, GetOwnershipsForDropDown());
                        SetDropDown(DrpProject, GetProjectsForDropDown());

                        drCurrentRow = dtFieldTable.NewRow();
                        drCurrentRow["RowNumber"] = i + 1;
                        dtFieldTable.Rows[i - 1]["DropOwnership"] = DrpOwnership.SelectedValue;
                        dtFieldTable.Rows[i - 1]["txtDimension"] = TextBoxDimension.Text;
                        dtFieldTable.Rows[i - 1]["CheckLast12"] = CheckLast12.SelectedValue;
                        dtFieldTable.Rows[i - 1]["txtFGpsN"] = txtFGpsN.Text;
                        dtFieldTable.Rows[i - 1]["txtFGpsE"] = txtFGpsE.Text;
                        dtFieldTable.Rows[i - 1]["DropProject"] = DrpProject.SelectedValue;

                        rowIndex++;
                    }

                    ViewState["FieldTable"] = dtFieldTable;
                    //FieldDetails.DataSource = dtFieldTable;
                    //FieldDetails.DataBind();
                }
            }
            else
            {
                Response.Write("ViewState is null");
            }
            //SetPreviousFieldData();
        }
        protected void FieldDetails_PreRender(object sender, EventArgs e)
        {
            ClientScriptManager cs = Page.ClientScript;
            foreach (GridViewRow grdrow in FieldDetails.Rows)
            {
                DropDownList drpgrdDropOwnership = (DropDownList)grdrow.FindControl("DropOwnership");
                TextBox txtgrdtxtDimension = (TextBox)grdrow.FindControl("txtDimension");
                CheckBoxList chkgrdCheckLast12 = (CheckBoxList)grdrow.FindControl("CheckLast12");
                DropDownList drpgrdDropProject = (DropDownList)grdrow.FindControl("DropProject");
                TextBox txtgrdFGpsN = (TextBox)grdrow.FindControl("txtFGpsN");
                TextBox txtgrdFGpsE = (TextBox)grdrow.FindControl("txtFGpsE");
                cs.RegisterArrayDeclaration("grdDropOwnership_Drp", String.Concat("'", drpgrdDropOwnership.ClientID, "'"));
                cs.RegisterArrayDeclaration("grdtxtDimension_Txt", String.Concat("'", txtgrdtxtDimension.ClientID, "'"));
                cs.RegisterArrayDeclaration("grdCheckLast12_Chk", String.Concat("'", chkgrdCheckLast12.ClientID, "'"));
                cs.RegisterArrayDeclaration("grdtxtFGpsN_Txt", String.Concat("'", txtgrdFGpsN.ClientID, "'"));
                cs.RegisterArrayDeclaration("grdtxtFGpsE_Txt", String.Concat("'", txtgrdFGpsE.ClientID, "'"));
                cs.RegisterArrayDeclaration("grdDropProject_Drp", String.Concat("'", drpgrdDropProject.ClientID, "'"));
            }
        }
        #endregion

        #region Crops GridView

        /*Get crops for drop down menu*/
        private IQueryable GetCropsForDropDown()
        {
            DataKibaliDataContext db = new DataKibaliDataContext();
            var items = from c in db.CROPs
                        select new
                        {
                            Text = c.Name,
                            Value = c.Name
                        };
            return items.OrderBy(x => x.Text);
        }

        public void CropFirstGridViewRow()
        {
            DataTable dt = new DataTable();
            DataRow dr = null;
            dt.Columns.Add(new DataColumn("RowNumber_", typeof(string)));
            dt.Columns.Add(new DataColumn("DropCropType", typeof(string)));
            dt.Columns.Add(new DataColumn("DropCropType2", typeof(string)));
            dt.Columns.Add(new DataColumn("DropCropType3", typeof(string)));
            dt.Columns.Add(new DataColumn("DropCropType4", typeof(string)));
            dr = dt.NewRow();
            dr["RowNumber_"] = 1;
            dr["DropCropType"] = string.Empty;
            dr["DropCropType2"] = string.Empty;
            dr["DropCropType3"] = string.Empty;
            dr["DropCropType4"] = string.Empty;
            dt.Rows.Add(dr);

            ViewState["CropTable"] = dt;


            CropDetails.DataSource = dt;
            CropDetails.DataBind();

            SetPreviousCropData();

            Button btnCropAdd = (Button)CropDetails.FooterRow.Cells[5].FindControl("ButtonCropAdd");
            Page.Form.DefaultFocus = btnCropAdd.ClientID;
        }

        private void AddNewCropRow()
        {
            int rowIndex = 0;

            if (ViewState["CropTable"] != null)
            {
                DataTable dtCropTable = (DataTable)ViewState["CropTable"];
                DataRow drCurrentRow = null;
                if (dtCropTable.Rows.Count > 0)
                {
                    for (int i = 1; i <= dtCropTable.Rows.Count; i++)
                    {
                        DropDownList DrpCropType = (DropDownList)CropDetails.Rows[rowIndex].Cells[1].FindControl("DropCropType");
                        DropDownList DrpCropType2 = (DropDownList)CropDetails.Rows[rowIndex].Cells[2].FindControl("DropCropType2");
                        DropDownList DrpCropType3 = (DropDownList)CropDetails.Rows[rowIndex].Cells[3].FindControl("DropCropType3");
                        DropDownList DrpCropType4 = (DropDownList)CropDetails.Rows[rowIndex].Cells[4].FindControl("DropCropType4");

                        SetDropDown(DrpCropType, GetCropsForDropDown());
                        SetDropDown(DrpCropType2, GetCropsForDropDown());
                        SetDropDown(DrpCropType3, GetCropsForDropDown());
                        SetDropDown(DrpCropType4, GetCropsForDropDown());

                        drCurrentRow = dtCropTable.NewRow();
                        drCurrentRow["RowNumber_"] = i + 1;

                        dtCropTable.Rows[i - 1]["DropCropType"] = DrpCropType.SelectedValue;
                        dtCropTable.Rows[i - 1]["DropCropType2"] = DrpCropType2.SelectedValue;
                        dtCropTable.Rows[i - 1]["DropCropType3"] = DrpCropType3.SelectedValue;
                        dtCropTable.Rows[i - 1]["DropCropType4"] = DrpCropType4.SelectedValue;

                        rowIndex++;
                    }
                    dtCropTable.Rows.Add(drCurrentRow);
                    ViewState["CropTable"] = dtCropTable;

                    CropDetails.DataSource = dtCropTable;
                    CropDetails.DataBind();
                }
            }
            else
            {
                Response.Write("ViewState is null");
            }
            SetPreviousCropData();
        }

        private void SetPreviousCropData()
        {
            int rowIndex = 0;
            if (ViewState["CropTable"] != null)
            {
                DataTable dt = (DataTable)ViewState["CropTable"];
                if (dt.Rows.Count > 0)
                {
                    for (int i = 0; i < dt.Rows.Count; i++)
                    {
                        DropDownList DrpCropType = (DropDownList)CropDetails.Rows[rowIndex].Cells[1].FindControl("DropCropType");
                        DropDownList DrpCropType2 = (DropDownList)CropDetails.Rows[rowIndex].Cells[2].FindControl("DropCropType2");
                        DropDownList DrpCropType3 = (DropDownList)CropDetails.Rows[rowIndex].Cells[3].FindControl("DropCropType3");
                        DropDownList DrpCropType4 = (DropDownList)CropDetails.Rows[rowIndex].Cells[4].FindControl("DropCropType4");
                        // drCurrentRow["RowNumber_"] = i + 1;

                        SetDropDown(DrpCropType, GetCropsForDropDown());
                        SetDropDown(DrpCropType2, GetCropsForDropDown());
                        SetDropDown(DrpCropType3, GetCropsForDropDown());
                        SetDropDown(DrpCropType4, GetCropsForDropDown());

                        CropDetails.Rows[i].Cells[0].Text = Convert.ToString(i + 1);
                        DrpCropType.SelectedValue = dt.Rows[i]["DropCropType"].ToString();
                        DrpCropType2.SelectedValue = dt.Rows[i]["DropCropType2"].ToString();
                        DrpCropType3.SelectedValue = dt.Rows[i]["DropCropType3"].ToString();
                        DrpCropType4.SelectedValue = dt.Rows[i]["DropCropType4"].ToString();
                        rowIndex++;
                    }
                }
            }
        }

        protected void ButtonCropAdd_Click(object sender, EventArgs e)
        {
            AddNewCropRow();
        }

        protected void CropDetails_RowDeleting(object sender, GridViewDeleteEventArgs e)
        {
            SetCropRowData();
            if (ViewState["CropTable"] != null)
            {
                DataTable dt = (DataTable)ViewState["CropTable"];
                DataRow drCurrentRow = null;
                int rowIndex = Convert.ToInt32(e.RowIndex);
                if (dt.Rows.Count > 1)
                {
                    dt.Rows.Remove(dt.Rows[rowIndex]);
                    drCurrentRow = dt.NewRow();
                    ViewState["CropTable"] = dt;
                    CropDetails.DataSource = dt;
                    CropDetails.DataBind();

                    for (int i = 0; i < CropDetails.Rows.Count - 1; i++)
                    {
                        CropDetails.Rows[i].Cells[0].Text = Convert.ToString(i + 1);
                    }
                    SetPreviousCropData();
                }
            }
        }
        private void SetCropRowData()
        {
            int rowIndex = 0;

            if (ViewState["CropTable"] != null)
            {
                DataTable dtCropTable = (DataTable)ViewState["CropTable"];
                DataRow drCurrentRow = null;
                if (dtCropTable.Rows.Count > 0)
                {
                    for (int i = 1; i <= dtCropTable.Rows.Count; i++)
                    {
                        DropDownList DrpCropType = (DropDownList)CropDetails.Rows[rowIndex].Cells[2].FindControl("DropCropType");
                        DropDownList DrpCropType2 = (DropDownList)CropDetails.Rows[rowIndex].Cells[3].FindControl("DropCropType2");
                        DropDownList DrpCropType3 = (DropDownList)CropDetails.Rows[rowIndex].Cells[4].FindControl("DropCropType3");
                        DropDownList DrpCropType4 = (DropDownList)CropDetails.Rows[rowIndex].Cells[5].FindControl("DropCropType4");

                        SetDropDown(DrpCropType, GetCropsForDropDown());
                        SetDropDown(DrpCropType2, GetCropsForDropDown());
                        SetDropDown(DrpCropType3, GetCropsForDropDown());
                        SetDropDown(DrpCropType4, GetCropsForDropDown());

                        drCurrentRow = dtCropTable.NewRow();
                        drCurrentRow["RowNumber_"] = i + 1;
                        dtCropTable.Rows[i - 1]["DropCropType"] = DrpCropType.SelectedValue;
                        dtCropTable.Rows[i - 1]["DropCropType2"] = DrpCropType2.SelectedValue;
                        dtCropTable.Rows[i - 1]["DropCropType3"] = DrpCropType3.SelectedValue;
                        dtCropTable.Rows[i - 1]["DropCropType4"] = DrpCropType4.SelectedValue;

                        rowIndex++;
                    }

                    ViewState["CropTable"] = dtCropTable;
                }
            }
            else
            {
                Response.Write("ViewState is null");
            }
        }
        protected void CropDetails_PreRender(object sender, EventArgs e)
        {
            ClientScriptManager cs = Page.ClientScript;
            foreach (GridViewRow grdrow in CropDetails.Rows)
            {
                DropDownList drpgrdDropCropType = (DropDownList)grdrow.FindControl("DropCropType");
                DropDownList drpgrdDropCropType2 = (DropDownList)grdrow.FindControl("DropCropType2");
                DropDownList drpgrdDropCropType3 = (DropDownList)grdrow.FindControl("DropCropType3");
                DropDownList drpgrdDropCropType4 = (DropDownList)grdrow.FindControl("DropCropType4");
                cs.RegisterArrayDeclaration("grdDropCropType_Drp", String.Concat("'", drpgrdDropCropType.ClientID, "'"));
                cs.RegisterArrayDeclaration("grdDropCropType_Drp2", String.Concat("'", drpgrdDropCropType2.ClientID, "'"));
                cs.RegisterArrayDeclaration("grdDropCropType_Drp3", String.Concat("'", drpgrdDropCropType3.ClientID, "'"));
                cs.RegisterArrayDeclaration("grdDropCropType_Drp4", String.Concat("'", drpgrdDropCropType4.ClientID, "'"));
            }
        }
        #endregion

        #region database section
        private void SaveHousehold(String Village, String HHNumber, String HHhead, DateTime date)
        {
            using (DataKibaliDataContext context = new DataKibaliDataContext())
            {
                HOUSEHOLD household = new HOUSEHOLD();
                if (Village != null || Village != "") household.Village = Village;
                if (HHNumber != null || HHNumber != "") household.HHNumber = HHNumber;
                if (HHhead != null || HHhead != "") household.HHhead = HHhead;
                if (date != null) household.InterviewDate = date;
                context.HOUSEHOLDs.InsertOnSubmit(household);
                context.SubmitChanges();
            }
        }
        private void SaveClaimer(String id, String FirstName, String MiddeName, String FamilyName, String HHNumber, String Interviewer, bool Supervisor, bool Chief)
        {
            using (DataKibaliDataContext context = new DataKibaliDataContext())
            {
                HHCLAIMER claimer = new HHCLAIMER();
                if (id != null || id != "") claimer.IDnumber = id;
                if (FirstName != null || FirstName != "") claimer.HHFirstName = FirstName;
                if (MiddeName != null || MiddeName != "") claimer.HHMiddleName = MiddeName;
                if (FamilyName != null || FamilyName != "") claimer.HHFamName = FamilyName;
                if (HHNumber != null || HHNumber != "") claimer.HHNumber = HHNumber;
                if (Interviewer != null || Interviewer != "") claimer.Interviewer = Interviewer;
                claimer.Supervised = Supervisor;
                claimer.Chiefed = Chief;
                claimer.AgriCompStatus = false;
                context.HHCLAIMERs.InsertOnSubmit(claimer);
                context.SubmitChanges();
            }
        }
        private void SaveTree(String id, String treename, int Number, string GpsN, string GpsE, String ProjectTask)
        {
            using (DataKibaliDataContext context = new DataKibaliDataContext())
            {
                COMP_TREE tree = new COMP_TREE();
                if (id != null || id != "") tree.IDnumber = id;
                if (treename != null || treename != "") tree.Tree = treename;
                if (Number != 0) tree.Number = Number;
                if (GpsN != null || GpsN != "") tree.GpsN = GpsN; else if (GpsN == "") tree.GpsN = null;
                if (GpsE != null || GpsE != "") tree.GpsE = GpsE; else if (GpsE == "") tree.GpsE = null;
                if (ProjectTask != "") tree.ProjectTask = ProjectTask;
                context.COMP_TREEs.InsertOnSubmit(tree);
                context.SubmitChanges();
            }
        }
        String GetUniqueFieldCode()
        {
            Random random = new Random();
            String FieldCode =  random.Next(0, 999999999)+"";
            DataKibaliDataContext db = new DataKibaliDataContext();
            bool contains = db.COMP_FIELDs.Any(x => x.FieldCode == FieldCode);
            if (contains) return GetUniqueFieldCode(); else return FieldCode;
        }
        private void SaveField(String id, String FieldCode, String Ownership, double dimension, bool Cultiv, String GpsN, String GpsE, String ProjectTask)
        {
            using (DataKibaliDataContext context = new DataKibaliDataContext())
            {
                COMP_FIELD field = new COMP_FIELD();
                if (id != null || id != "") field.IDnumber = id;
                if (FieldCode != null || FieldCode != "") field.FieldCode = FieldCode;
                if (Ownership != null || Ownership != "") field.Ownership = Ownership;
                if (dimension != 0 || dimension != 0.0) field.Dimension = dimension;
                field.Cultiv = Cultiv;
                if (GpsN != null || GpsN != "") field.GpsN = GpsN; else if (GpsN == "") field.GpsN = null;
                if (GpsE != null || GpsE != "") field.GpsE = GpsE; else if (GpsE == "") field.GpsE = null;
                if (ProjectTask != "") field.ProjectTask = ProjectTask;
                context.COMP_FIELDs.InsertOnSubmit(field);
                context.SubmitChanges();
            }
        }
        private void SaveCrop(String id, String FieldCode, String cropname)
        {
            using (DataKibaliDataContext context = new DataKibaliDataContext())
            {
                COMP_CROP crop = new COMP_CROP();
                if (id != null || id != "") crop.IDnumber = id;
                if (FieldCode != null || FieldCode != "") crop.FieldCode = FieldCode;
                if (cropname != null || cropname != "") crop.Crop = cropname;
                if (cropname != "0" && cropname != "none")
                {
                    context.COMP_CROPs.InsertOnSubmit(crop);
                    context.SubmitChanges();
                }
            }
        }
        private void SaveAdditional(String id, bool unresearched, String Location, String Respcomm, String Fieldcomm)
        {
            using (DataKibaliDataContext context = new DataKibaliDataContext())
            {
                FURTHER_INFO additional = new FURTHER_INFO();
                if (id != null || id != "") additional.IDnumber = id;
                additional.FTunresearched = unresearched;
                if (Location != null || Location != "") additional.Location = Location;
                if (Respcomm != null || Respcomm != "") additional.RespComm = Respcomm;
                if (Fieldcomm != null || Fieldcomm != "") additional.FieldComm = Fieldcomm;
                context.FURTHER_INFOs.InsertOnSubmit(additional);
                context.SubmitChanges();
            }
        }
        /*SAVE ALL TABS*/
        int txtnum = 0;
        string ProjectTask = ""; //field
        string DropDownProject2 = ""; //tree
        bool Cultiv = false;
        protected void cmdsave_Click(object sender, EventArgs e)
        {
            Master master = new Master();
            int accesslevel = master.GetAccessLevel(User.Identity.Name.ToString());
            if (accesslevel > 0)
            {
                if ((!master.isinHOUSEHOLD(txthhnumber.Text)) && (!master.isinHHCLAIMER(txtid.Text)))
                {
                    Label1.Text = "Saving houseHold information, please wait...";

                    string village = DropDownVillage.SelectedValue;
                    string hhnumber = txthhnumber.Text;
                    string hhhead = txthead.Text;
                    DateTime date = Convert.ToDateTime(txtinterviewdate.Text);
                    SaveHousehold(village, hhnumber, hhhead, date); //SAVING HOUSEHOLD

                    String id = txtid.Text;

                    String FirstName = txtFirstName.Text;
                    String MiddeName = txtMidname.Text;
                    String FamilyName = txtFamname.Text;
                    String HHNumber = txthhnumber.Text;
                    String Interviewer = DropDownInterviewer.SelectedValue;
                    bool Supervisor = CheckSupervisor.Checked;
                    bool Chief = CheckChef.Checked;
                    SaveClaimer(id, FirstName, MiddeName, FamilyName, HHNumber, Interviewer, Supervisor, Chief);//SAVING CLAIMER

                    if (!chkTrees.Checked)
                    {
                        SetTreeRowData();
                        DataTable Tree_Table = ViewState["TreeTable"] as DataTable;

                        if (Tree_Table != null)
                        {
                            foreach (DataRow row in Tree_Table.Rows)
                            {
                                txtnum = 0; //these are to make sure the previous value doesn't cache into the next, if next is blank
                                string DropDownTree = row.ItemArray[1] as string;
                                string Temptxtprod1 = row.ItemArray[2] as string;
                                if (Temptxtprod1 != "") txtnum = Int32.Parse(Temptxtprod1);
                                string GpsN = row.ItemArray[3] as string;
                                string GpsE = row.ItemArray[4] as string;
                                string TempDropDownProject2 = row.ItemArray[5] as string;
                                if (TempDropDownProject2 == "0") DropDownProject2 = ""; else DropDownProject2 = TempDropDownProject2;

                                SaveTree(id, DropDownTree, txtnum, GpsN, GpsE, DropDownProject2);//SAVING TREE
                            }
                        }
                    }
                    if (!chkFields.Checked)
                    {
                        SetFieldRowData();
                        SetCropRowData();
                        DataTable Field_Table = ViewState["FieldTable"] as DataTable;
                        DataTable Crop_Table = ViewState["CropTable"] as DataTable;

                        if (Field_Table != null)
                        {
                            int rownum = 0;
                            foreach (DataRow row in Field_Table.Rows)
                            {
                                rownum += 1;
                                string FieldCode = GetUniqueFieldCode();
                                string Ownership = row.ItemArray[1] as string;
                                string Tempdimension = row.ItemArray[2] as string;
                                double dimension = Convert.ToDouble(Tempdimension);
                                string TempCultiv = row.ItemArray[3] as string;
                                if (TempCultiv == "1") Cultiv = true; else Cultiv = false;
                                string GpsN = row.ItemArray[4] as string;
                                string GpsE = row.ItemArray[5] as string;
                                string TempProjectTask = row.ItemArray[6] as string;
                                if (TempProjectTask == "0") ProjectTask = ""; else ProjectTask = TempProjectTask;
                                SaveField(id, FieldCode, Ownership, dimension, Cultiv, GpsN, GpsE, ProjectTask);//SAVING FIELD

                                string cropname = Crop_Table.Rows[rownum - 1].ItemArray[1] as string;
                                string cropname2 = Crop_Table.Rows[rownum - 1].ItemArray[2] as string;
                                string cropname3 = Crop_Table.Rows[rownum - 1].ItemArray[3] as string;
                                string cropname4 = Crop_Table.Rows[rownum - 1].ItemArray[4] as string;
                                SaveCrop(id, FieldCode, cropname);//SAVING CROP
                                SaveCrop(id, FieldCode, cropname2);//SAVING CROP
                                SaveCrop(id, FieldCode, cropname3);//SAVING CROP
                                SaveCrop(id, FieldCode, cropname4);//SAVING CROP
                            }
                        }
                    }
                    string location = txtLocation.Text;
                    string resp = txtRespCom.Text;
                    string field = txtFieldCom.Text;
                    SaveAdditional(id, CheckUnresearched.Checked, location, resp, field);//SAVING FURTHER INFO

                    Label1.Text = "HouseHold " + txthhnumber.Text + " saved";
                    Response.Redirect("Confirmation.aspx?hhn=" + txthhnumber.Text + "&hhname=" + txthead.Text);
                    //cmdsave.Visible = false;////////////////////////////////////////////////
                }

                else if (master.isinHOUSEHOLD(txthhnumber.Text)) Response.Write("<script>alert('The household number provided already exists in DB');</script>");
                else if (master.isinHHCLAIMER(txtid.Text)) Response.Write("<script>alert('The Id number provided already exists in DB');</script>");
            }
            else Response.Write("<script>alert('You do not have the sufficient privileges to perform this operation');</script>");
        }

        #endregion
    }
}