﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

namespace basekibali
{
    public partial class CaptureClaimer : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            jsvill.Text = "Select Village|" + getJSvillages();
            jsint.Text = "Select Interviewer|" + getJSinterview();
        }
        private string getJSvillages()
        {
            string villages = "";
            DataKibaliDataContext db = new DataKibaliDataContext();
            var items = from v in db.VILLAGEs
                        select new
                        {
                            v.Name
                        };
            foreach (var value in items)
            {
                villages += value.Name + "|";
            }
            return villages;
        }
        private string getJSinterview()
        {
            string interviewer = "";
            DataKibaliDataContext db = new DataKibaliDataContext();
            var items = from v in db.INTERVIEWERs
                        select new
                        {
                            v.Name
                        };
            foreach (var value in items)
            {
                interviewer += value.Name + "|";
            }
            return interviewer;
        }
        [System.Web.Services.WebMethod]
        public static string CheckId(string args)
        {
            string[] arguments = args.Split('|');
            Master master = new Master();
            bool id = master.isinHHCLAIMER(arguments[0]);
            bool hh = master.isinHOUSEHOLD(arguments[1]);
            if ((id) && (hh)) return "both";
            else if ((id) && (hh == false)) return "id";
            if ((id == false) && (hh)) return "hh";
            else return "";
        }
        protected void serverbutton_Click(object sender, EventArgs e)
        {
            #region saving to db
            /*saving into db*/
            string village = Request["DropDownVillage"];
            string hhnumber = Request["txthhnumber"];
            string hhhead = Request["txthead"];
            DateTime date = Convert.ToDateTime(txtinterviewdate.Text);
            SaveHousehold(village, hhnumber, hhhead, date); //SAVING HOUSEHOLD

            String id = Request["txtid"];

            String FirstName = Request["txtFirstName"];
            String MiddeName = Request["txtMidname"];
            String FamilyName = Request["txtFamname"];
            String Interviewer = Request["DropDownInterviewer"];

            bool Supervisor = false;
            bool Chief = false;
            if (Request["DropDownSupervisor"].Equals("Yes")) Supervisor = true;
            if (Request["DropDownChef"].Equals("Yes")) Chief = true;

            SaveClaimer(id, FirstName, MiddeName, FamilyName, hhnumber, Interviewer, Supervisor, Chief);//SAVING CLAIMER
            #endregion
            
            #region saving photo
            PhotoUploader uploader = new PhotoUploader();
            uploader.savephoto(Label1, fileUploader, Request["txthhnumber"]);
            if (Label1.Text == "0")
            {
                Label1.ForeColor = System.Drawing.Color.Black;
                Label1.Text = "No photo attached";
            }
            else if (Label1.Text == "-1")
            {
                Label1.ForeColor = System.Drawing.Color.Red;
                Label1.Text = "File size cannot be larger than 3MB";
            }
            else if (Label1.Text == "-2")
            {
                Label1.ForeColor = System.Drawing.Color.Red;
                Label1.Text = "Only jpg/jpeg File Type is supported";
            }
            else if (Label1.Text == "1")
            {
                Label1.ForeColor = System.Drawing.Color.Black;
                Label1.Text = "Photo successfully saved";

                Response.Redirect("SuccessPage.aspx");
            }
            #endregion

        }
        #region database methods
        private void SaveHousehold(String Village, String HHNumber, String HHhead, DateTime date)
        {
            using (DataKibaliDataContext context = new DataKibaliDataContext())
            {
                HOUSEHOLD household = new HOUSEHOLD();
                if (Village != null || Village != "") household.Village = Village;
                if (HHNumber != null || HHNumber != "") household.HHNumber = HHNumber;
                if (HHhead != null || HHhead != "") household.HHhead = HHhead;
                if (date != null) household.InterviewDate = date;
                context.HOUSEHOLDs.InsertOnSubmit(household);
                context.SubmitChanges();
            }
        }
        private void SaveClaimer(String id, String FirstName, String MiddeName, String FamilyName, String HHNumber, String Interviewer, bool Supervisor, bool Chief)
        {
            using (DataKibaliDataContext context = new DataKibaliDataContext())
            {
                HHCLAIMER claimer = new HHCLAIMER();
                if (id != null || id != "") claimer.IDnumber = id;
                if (FirstName != null || FirstName != "") claimer.HHFirstName = FirstName;
                if (MiddeName != null || MiddeName != "") claimer.HHMiddleName = MiddeName;
                if (FamilyName != null || FamilyName != "") claimer.HHFamName = FamilyName;
                if (HHNumber != null || HHNumber != "") claimer.HHNumber = HHNumber;
                if (Interviewer != null || Interviewer != "") claimer.Interviewer = Interviewer;
                claimer.Supervised = Supervisor;
                claimer.Chiefed = Chief;
                claimer.AgriCompStatus = false;
                context.HHCLAIMERs.InsertOnSubmit(claimer);
                context.SubmitChanges();
            }
        }
        #endregion
    }
}