﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

namespace basekibali
{
    public partial class EditTreesFields : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            jsown.Text = "Select Ownership|" + getJSownerships();
            jsproj.Text = "Affecting Project/Task (If any)|" + getJSprojects();
            jscrop.Text = "Select Crop|" + getJScrops();
            jstree.Text = "Select Tree|" + getJStrees();
            jstproj.Text = "Affecting Project/Task (If any)|" + getJSprojects();
            /*
            fieldpanel.Visible = true;
            if (Request.QueryString["h"] != null)
            {
                Response.Write("From Page1 h value=" + Request.QueryString["h"]);
                string which = Request.QueryString["h"];
                if (which == "f") fieldpanel.Visible = false;
            }
            */
        }
        private string getJSownerships()
        {
            string ownerships = "";
            DataKibaliDataContext db = new DataKibaliDataContext();
            var items = from v in db.FIELDSOWNERSHIPs
                        select new
                        {
                            v.Title
                        };
            foreach (var value in items)
            {
                ownerships += value.Title + "|";
            }
            return ownerships;
        }
        private string getJSprojects()
        {
            string projects = "";
            DataKibaliDataContext db = new DataKibaliDataContext();
            var items = from v in db.PROJECTs
                        select new
                        {
                            v.Name
                        };
            foreach (var value in items)
            {
                projects += value.Name + "|";
            }
            return projects;
        }
        private string getJScrops()
        {
            string crops = "";
            DataKibaliDataContext db = new DataKibaliDataContext();
            var items = from v in db.CROPs
                        select new
                        {
                            v.Name
                        };
            foreach (var value in items)
            {
                crops += value.Name + "|";
            }
            return crops;
        }
        private string getJStrees()
        {
            string trees = "";
            DataKibaliDataContext db = new DataKibaliDataContext();
            var items = from v in db.TREEs
                        select new
                        {
                            v.Name
                        };
            foreach (var value in items)
            {
                trees += value.Name + "|";
            }
            return trees;
        }
        protected void Button1_Click(object sender, EventArgs e)
        {
            string id = Request.QueryString["id"];

            if (Request.QueryString["h"].Equals("f"))
            {
                string[] trees = Request["trees1"].Split(',');
                string[] number = Request["numtrees1"].Split(',');
                string[] TGpsN = Request["TgpsN1"].Split(',');
                string[] TGpsE = Request["TgpsE1"].Split(',');
                string[] TProjects = Request["Tproject1"].Split(',');

                for (int i = 0; i <= trees.Length - 1; i++)
                {
                    string proj = TProjects[i];
                    if (proj.Equals("0")) proj = "";
                    SaveTree(id, trees[i], Convert.ToInt32(number[i]), TGpsN[i], TGpsE[i], proj);//SAVING TREE
                }
            }

            if (Request.QueryString["h"].Equals("t"))
            {
                string[] ownerships = Request["ownership1"].Split(',');
                string[] dimensions = Request["dimension1"].Split(',');
                string[] last12 = Request["clast1"].Split(',');
                string[] FGpsN = Request["FgpsN1"].Split(',');
                string[] FGpsE = Request["FgpsE1"].Split(',');
                string[] FProjects = Request["Fproject1"].Split(',');

                string[] Crop1 = Request["C1-1"].Split(',');
                string[] Crop2 = Request["C2-1"].Split(',');
                string[] Crop3 = Request["C3-1"].Split(',');
                string[] Crop4 = Request["C4-1"].Split(',');

                for (int i = 0; i <= ownerships.Length - 1; i++)
                {
                    string FieldCode = GetUniqueFieldCode();

                    string proj = FProjects[i];
                    if (proj.Equals("0")) proj = "";
                    bool last = false;
                    if (last12[i].Equals("Yes")) last = true;
                    SaveField(id, FieldCode, ownerships[i], Convert.ToDouble(dimensions[i]), last, FGpsN[i], FGpsE[i], proj);//SAVING FIELD
                    SaveCrop(id, FieldCode, Crop1[i]);//SAVING CROP
                    SaveCrop(id, FieldCode, Crop2[i]);//SAVING CROP
                    SaveCrop(id, FieldCode, Crop3[i]);//SAVING CROP
                    SaveCrop(id, FieldCode, Crop4[i]);//SAVING CROP
                }
            }
            Response.Redirect("saved.aspx");
        }
        private void SaveTree(String id, String treename, int Number, string GpsN, string GpsE, String ProjectTask)
        {
            using (DataKibaliDataContext context = new DataKibaliDataContext())
            {
                COMP_TREE tree = new COMP_TREE();
                if (id != null || id != "") tree.IDnumber = id;
                if (treename != null || treename != "") tree.Tree = treename;
                if (Number != 0) tree.Number = Number;
                if (GpsN != null || GpsN != "") tree.GpsN = GpsN; else if (GpsN == "") tree.GpsN = null;
                if (GpsE != null || GpsE != "") tree.GpsE = GpsE; else if (GpsE == "") tree.GpsE = null;
                if (ProjectTask != "") tree.ProjectTask = ProjectTask;
                context.COMP_TREEs.InsertOnSubmit(tree);
                context.SubmitChanges();
            }
        }
        String GetUniqueFieldCode()
        {
            Random random = new Random();
            String FieldCode = random.Next(0, 999999999) + "";
            DataKibaliDataContext db = new DataKibaliDataContext();
            bool contains = db.COMP_FIELDs.Any(x => x.FieldCode == FieldCode);
            if (contains) return GetUniqueFieldCode(); else return FieldCode;
        }
        private void SaveField(String id, String FieldCode, String Ownership, double dimension, bool Cultiv, String GpsN, String GpsE, String ProjectTask)
        {
            using (DataKibaliDataContext context = new DataKibaliDataContext())
            {
                COMP_FIELD field = new COMP_FIELD();
                if (id != null || id != "") field.IDnumber = id;
                if (FieldCode != null || FieldCode != "") field.FieldCode = FieldCode;
                if (Ownership != null || Ownership != "") field.Ownership = Ownership;
                if (dimension != 0 || dimension != 0.0) field.Dimension = dimension;
                field.Cultiv = Cultiv;
                if (GpsN != null || GpsN != "") field.GpsN = GpsN; else if (GpsN == "") field.GpsN = null;
                if (GpsE != null || GpsE != "") field.GpsE = GpsE; else if (GpsE == "") field.GpsE = null;
                if (ProjectTask != "") field.ProjectTask = ProjectTask;
                context.COMP_FIELDs.InsertOnSubmit(field);
                context.SubmitChanges();
            }
        }
        private void SaveCrop(String id, String FieldCode, String cropname)
        {
            using (DataKibaliDataContext context = new DataKibaliDataContext())
            {
                COMP_CROP crop = new COMP_CROP();
                if (id != null || id != "") crop.IDnumber = id;
                if (FieldCode != null || FieldCode != "") crop.FieldCode = FieldCode;
                if (cropname != null || cropname != "") crop.Crop = cropname;
                if (cropname != "0" && cropname != "none")
                {
                    context.COMP_CROPs.InsertOnSubmit(crop);
                    context.SubmitChanges();
                }
            }
        }
    }
}