﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Drawing;
using System.Text.RegularExpressions;
using System.Net.Mail;
using System.Net;

namespace basekibali
{
    public partial class ManageAccounts : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if (User.Identity.IsAuthenticated) { }
            else
                Response.Redirect("~/Default.aspx");
        }
        static string[] EngArray = { "angel", "angry", "anxious", "citrus", "comment", "elbow", "empty", "engine", "foible", "foyer", "hundred", "husband", "liquid", "luggage", "neutron", "nothing", "olive", "penguin", "poem", "polka", "problem", "sanction", "sandwich", "secret", "something", "zigzag", "perfect", "plastic", "country", "possible"};//30
        protected void btnCreate_Click(object sender, EventArgs e)
        {
            Master master = new Master();
            int accesslevel = master.GetAccessLevel(User.Identity.Name.ToString());
            if (accesslevel == 3)
            {
                lblInfo.Text = "";
                if (IsValidEmail(txtemail.Text))
                {
                    if (!isinSecrity(txtemail.Text))
                    {
                        Random random = new Random();
                        int passwordpos = random.Next(0, 29);
                        string password = EngArray[passwordpos];
                        using (DataKibaliDataContext db = new DataKibaliDataContext())
                        {
                            SECURITY user = new SECURITY();
                            user.Username = txtemail.Text;
                            user.Password = password;
                            user.AccessLevel = Convert.ToInt32(ddlLevel.SelectedValue);
                            db.SECURITies.InsertOnSubmit(user);
                            db.SubmitChanges();
                        }
                        SendMail(txtemail.Text.ToString(),password,ddlLevel.SelectedItem+"");
                        lblInfo.ForeColor = Color.DarkBlue;
                        lblInfo.Text = "You have successfully created a " + ddlLevel.SelectedItem + " account.<br/> An email has been sent to " + txtemail.Text + " with the login details";
                        txtemail.Text = "";
                        ddlLevel.SelectedIndex = 0;
                    }
                    else
                    {
                        lblInfo.ForeColor = Color.Red;
                        lblInfo.Text = "This user already exists";
                    }
                }
                else
                {
                    lblInfo.ForeColor = Color.Red;
                    lblInfo.Text = "Invalide email address";
                }
            }
            else Response.Write("<script>alert('You do not have the sufficient privileges to complete this operation');</script>");
        }
        public const string MatchEmailPattern =
            @"^(([\w-]+\.)+[\w-]+|([a-zA-Z]{1}|[\w-]{2,}))@"
     + @"((([0-1]?[0-9]{1,2}|25[0-5]|2[0-4][0-9])\.([0-1]?
				[0-9]{1,2}|25[0-5]|2[0-4][0-9])\."
     + @"([0-1]?[0-9]{1,2}|25[0-5]|2[0-4][0-9])\.([0-1]?
				[0-9]{1,2}|25[0-5]|2[0-4][0-9])){1}|"
     + @"([a-zA-Z]+[\w-]+\.)+[a-zA-Z]{2,4})$";
        bool IsValidEmail(string email)
        {
            if (email != null) return Regex.IsMatch(email, MatchEmailPattern);
            else return false;
        }
        private bool isinSecrity(string username)
        {
            DataKibaliDataContext db = new DataKibaliDataContext();
            bool contains = db.SECURITies.Any(x => x.Username == username);
            return contains;
        }
        protected void SendMail(string emailaddress, string password, string level)
        {
            // Gmail Address from where you send the mail
            var fromAddress = "noreply@kibalibase.net";
            // any address where the email will be sending
            var toAddress = emailaddress;
            //Password of your gmail address
            const string fromPassword = "password1";
            // Passing the values and make a email formate to display
            string subject = "Your Kibalibase account";
            string body = "Hi,"+"\n";
            body += "Welcome to Kibalibase.net, this is an automated message." + "\n";
            body += "A " + level + " account has been created for you. Below are your log-in details:" + "\n\n";
            body += "Username: " + emailaddress + "\n";
            body += "Temporary Password: " + password + "\n";
            body += "\nRegards\nAdmin";
            // smtp settings
            var smtp = new System.Net.Mail.SmtpClient();
            {
                smtp.Host = "mail.kibalibase.net";
                //smtp.Port = 587;
                //smtp.EnableSsl = true;
                smtp.DeliveryMethod = System.Net.Mail.SmtpDeliveryMethod.Network;
                smtp.Credentials = new NetworkCredential(fromAddress, fromPassword);
                smtp.Timeout = 20000;
            }
            // Passing values to smtp object
            smtp.Send(fromAddress, toAddress, subject, body);
        }
    }
}